
#include "system_conf.h"
# define C_NUM_DISPLAY_LINES 600
# define C_NUM_PIXELS_PER_LINE 800
# define RUN_ALL

#define initx 369
#define inity 6
#define initX 415
#define initY 584
////////////////////////////
#define buttonL 84

#define whitex 11
#define whitey 505

#define yellowx 105
#define yellowy 505

#define redx 198
#define redy 505
//////////////////////////
#define Predx 141
#define Predy 11

#define Pyellowx 141
#define Pyellowy 96

#define Pwinx 141
#define Pwiny 183
/////////////////////////

#define player1_yellowx 9
#define player1_yellowy 12
#define player1_yellowX 40
#define player1_yellowY 479

#define player2_redx 49
#define player2_redy 12
#define player2_redX 40
#define player2_redY 479

#define player_grayx 93
#define player_grayy 12
#define player_grayX 40
#define player_grayY 413

///////////////////////////// GRAFICA
#define COLOR		unsigned short
void PUT_PIXEL(int X,int Y,int C)
{
*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + 0x180000) + ((Y)*800) + X))= (unsigned short) C;
}

static void bresenham_line(int x_start, int x_end, int y_start, int y_end, COLOR color)
{
	int dx;
	int dy;
	int x;
	int y;
	int error;

	dx = x_end - x_start;
	x  = x_start;
	y  = y_start;

    if(y_end > y_start){
    	dy = y_end-y_start;
		if(dy <= dx){
			error = dx>>1;	/* achieves dx/2 */
			while(x < x_end){
				x++;
				error -= dy;
				if(error < 0){
					y++;
					error += dx;
				}
				PUT_PIXEL(x, (C_NUM_DISPLAY_LINES-y-1), color);
//				c_vid[((C_NUM_LINES-y-1)*C_NUM_PIXELS_PER_LINE)+x] = pix_val;
			}
		}else{
			error = dy >> 1;
			while(y < y_end){
				y++;
				error -= dx;
				if(error < 0){
					x++;
					error += dy;
				}
				PUT_PIXEL(x, (C_NUM_DISPLAY_LINES-y-1), color);
//				c_vid[((C_NUM_LINES-y-1)*C_NUM_PIXELS_PER_LINE)+x] = pix_val;
			}
		}
	} else {
		/* negative slope */
		dy = y_start - y_end;
		if(dy >= dx){
			error = dy >> 1;
			while(y > y_end){
				y--;
				error -= dx;
				if(error < 0){
					x++;
					error += dy;
				}
				PUT_PIXEL(x, (C_NUM_DISPLAY_LINES-y-1), color);
//				c_vid[((C_NUM_LINES-y-1)*C_NUM_PIXELS_PER_LINE)+x] = pix_val;
			}
		}else{
			error = dx>>1;	/* achieves dx/2 */
			while(x < x_end){
				x++;
				error -= dy;
				if(error < 0){
					y--;
					error += dx;
				}
				PUT_PIXEL(x, (C_NUM_DISPLAY_LINES-y-1), color);
//				c_vid[((C_NUM_LINES-y-1)*C_NUM_PIXELS_PER_LINE)+x] = pix_val;
			}
		}
    }
}



/* draw a line */
void c_draw_line(int x_start, int x_end, int y_start, int y_end, COLOR color)
{
	/* check x_start argument */
	if(x_start > C_NUM_PIXELS_PER_LINE-1){
		return;
	}


	/* check x-end argument */
	if(x_end > (C_NUM_PIXELS_PER_LINE-1)){
		x_end = C_NUM_PIXELS_PER_LINE - 1;
	}


	/* check y-start argument */
	if(y_start > (C_NUM_DISPLAY_LINES-1)){
		return;
	}


	/* check y-end argument */
	if(y_end > (C_NUM_DISPLAY_LINES-1)){
		y_end = C_NUM_DISPLAY_LINES-1;
	}


	/* draw a line */
	if(x_start == x_end){
		/* vertical line */
		int i;
		for(i = y_start; i <= y_end; i++){
			PUT_PIXEL(x_start, i, color);
		}
	}else if(y_start == y_end){
		/* horizontal line */
		int i;
		for(i = x_start; i <= x_end; i++){
			PUT_PIXEL(i, y_start, color);
		}
	}else{
		/* flip fourth quadrant coords into first quadrant coords */
		y_start = (C_NUM_DISPLAY_LINES-1)-y_start;
		y_end   = (C_NUM_DISPLAY_LINES-1)-y_end;
		bresenham_line(x_start, x_end, y_start, y_end, color);
	}
}
//////////////////////////// fine GRAFICA
void attesa_1 (int s)
{
	int j, k;
	for (k=0; k<s; k++)
		for (j=0; j<1000; )
			j++;
}

int Copy (int src_page_addr, int x, int y, int X, int Y, int dst_page_addr, int tox, int toy)
// src_page_addr = indirizzo iniziale della pagina sorgente (che contiene l'icona da copiare)
// x, y = vertice sup sx dell'icona sorgente
// X, Y = dimensioni in num_colonne e num_righe della icona sorgente
// dst_page_addr = indirizzo iniziale della pagina di destinazione (su cui l'icona viene copiata)
// tox, toy = vertice sup sx dell'icona destinazione
{
	int h, k;
	for (k=0; k<X; k++)
		for (h=0; h<Y; h++)
		{
			*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + dst_page_addr) + (((toy+h)*800) + k + tox)))= *((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + src_page_addr) + (((y+h)*800) + k + x)));
		}
	return 0;
}

char leggitasti (void)
{
	char aa = 0;
	char bb = 0;
	aa = *(volatile unsigned char *) TASTI_BASE_ADDRESS;
	while (aa == 0x7)
		aa = *(volatile unsigned char *) TASTI_BASE_ADDRESS;
	bb = *(volatile unsigned char *) TASTI_BASE_ADDRESS;
	while (bb != 0x7)
			bb = *(volatile unsigned char *) TASTI_BASE_ADDRESS;
	return aa;
}

int Fill (int page_dest, int X, int Y, int tox, int toy, short col)
// page_dest = indirizzo della pagina di destinazione
// X, Y = dimensioni in num_colonne e num_righe del rettangolo da riempire
// tox , toy = vertice sup sx dell'icona destinazione
// col = colore (16 bit formato rgb565)
{
	int h, k;
	for (k = 0; k < X; k++)
		for (h = 0; h < Y; h++)
		{
			*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + page_dest) + (((toy+h)*800) + k + tox))) = col;
		}
	return 0;
}

int copia_da_pag (int ind_dest, int x, int y, int X, int Y, int ind_pag, int tox, int toy)
//ind_dest = indirizzo della pagina su cui copio
// x, y = vertice sup sx dell'icona sorgente
// X, Y = dimensioni in colonna e riga della icona da copiare
// ind_pag = indirizzo della pag destinazione
// tox , toy = vertice sup sx dell'icona destinazione
{
	int h, k;
	for (k=0; k<X; k++)
		for (h=0; h<Y; h++)
		{
		*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_dest) + (((toy+h)*800) + k + tox)))= *((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_pag) + (((y+h)*800) + k + x)));
		}
return 0;
}
int copia_da_pag_trasp_vert (int ind_dest, int x, int y, int X, int Y, int ind_pag, int tox, int toy)
{
	int h, k;
	unsigned short temp ;
	for (h=0; h<Y; h++)
	for (k=0; k<X; k++)
		//for (h=0; h<Y; h++)
		{
			temp = *((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_pag) + (((y+h)*800) + k + x)));
			if (temp != 0xFFFF)
				*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_dest) + (((toy+h)*800) + k + tox))) = temp;
		}
	return 0;
}


int pallino_gioco(int tipo)
{
	if (tipo == 1)
	{
		Fill (0x80000, buttonL, buttonL, 638, 410, 0xFFFF);
		copia_da_pag_trasp_vert (0x80000, Predx, Predy, buttonL, buttonL, 0x0, 455, 410);
	}
	else
	{
		Fill (0x80000, buttonL, buttonL, 455, 410, 0xFFFF);
		copia_da_pag_trasp_vert (0x80000, Predx, Predy, buttonL, buttonL, 0x0, 638, 410);
	}

	return 0;
}



int casella (int x, int y, int tipo)
{
	//Fill (0x100000, buttonL, buttonL, 90 + ((x-1)*buttonL), 70 + ((y-1)*buttonL) , 0xFF);
	if (tipo == 0) //white
		copia_da_pag (0x100000, whitex, whitey, buttonL, buttonL, 0x0, 90 + ((x-1)*buttonL), 84 + ((y-1)*buttonL));
	if (tipo == 2) //yellow
			copia_da_pag (0x100000, yellowx, yellowy, buttonL, buttonL, 0x0, 90 + ((x-1)*buttonL), 84 + ((y-1)*buttonL));
	if (tipo == 1) //red
			copia_da_pag (0x100000, redx, redy, buttonL, buttonL, 0x0, 90 + ((x-1)*buttonL), 84 + ((y-1)*buttonL));
	if (tipo == 3) //WIN
		copia_da_pag_trasp_vert (0x100000, Pwinx, Pwiny, buttonL, buttonL, 0x0, 92 + ((x-1)*buttonL), 90 + ((y-1)*buttonL));
			//Fill (0x100000, buttonL/2, buttonL/2, 90+ 21 + ((x-1)*buttonL), 84 + 21 + ((y-1)*buttonL), 0xFFFF);
	return 0;
}
int  seleziona(int colore, int pos_corr)
{
	int posizione = 0;
	int posizione_last = 0;
	int aa = 0;
	int lancio = 0;
	int currentx, currenty;
	posizione = pos_corr;
	if (colore == 1)
	{
		currentx = Predx;
		currenty = Predy;
	}
	else
	{
		currentx = Pyellowx;
		currenty = Pyellowy;
	}

	copia_da_pag_trasp_vert (0x100000, currentx, currenty, buttonL, buttonL, 0x0, 90 + ((posizione)*buttonL), 1);
	while (lancio == 0) // finch non si lancia
	{
		aa = leggitasti();
		posizione_last = posizione;
		if (aa == 0x6)
		{
			posizione = posizione + 1;
			if (posizione == 7)
				posizione = 0;
		}
		if (aa == 0x3)
		{
			posizione = posizione - 1;
			if (posizione < 0)
				posizione = 6;
		}
		if (aa == 0x5)
		{
			lancio = 1;
			Fill (0x100000, buttonL, buttonL-2, 90 + ((posizione)*buttonL), 1, 0xFFFF);
		}
		if (posizione != posizione_last)
		{
			Fill (0x100000, buttonL, buttonL, 90 + ((posizione_last)*buttonL), 1, 0xFFFF);
			copia_da_pag_trasp_vert (0x100000, currentx, currenty, buttonL, buttonL, 0x0, 90 + ((posizione)*buttonL), 1);
		}
	}
return posizione;
}


void  seleziona_CPU(void)
{

}


char controlla_colonna (char matrice[8][7], int posx, int posy, int player)
{
	int vinto = 0;
	short i;
	if (posy >= 3)
	{
		if ((matrice[posx][posy-3]) == ((char) player))
			if ((matrice[posx][posy-2])  == ((char) player))
				if ((matrice[posx][posy-1]) == ((char) player))
					if ((matrice[posx][posy])  == ((char) player))
					{
						vinto = 1;

					}

	}


	return vinto;
}

char controlla_riga (char matrice[8][7], int posx, int posy, int player)
{
	int vinto = 0;
	int i;
	char contatore = 0;
	for (i=posx; i <= 6; i++)
	{
		if ((matrice[i][posy]) == player )
			contatore = contatore + 1;
		else
			i = 7;
	}

	for (i=posx-1; i >= 0; i--)
	{
		if ((matrice[i][posy]) == player )
			contatore = contatore + 1;
		else
			i = -1;
	}
	if (contatore >= 4)
		vinto = 1;
	return vinto;
}

char controlla_diagonale_up (char matrice[8][7], int posx, int posy, int player)
{
	int vinto = 0;
	int i;
	char contatore = 0;
	for (i=0; i <= 6; i++)
	{
	  if ((posx+i) <= 6)
	   if ((posy+i) <= 5)
	   {
		   if ((matrice[posx+i][posy+i]) == player )
		   			contatore = contatore + 1;
		   	else
		   			i = 7;
	   }
	}

	for (i=1; i <= 6; i++)
	{
	  if ((posx-i) >= 0)
	   if ((posy-i) >= 0)
	   {
		if ((matrice[posx-i][posy-i]) == player )
			contatore = contatore + 1;
		else
			i = 7;
	   }
	}
	if (contatore >= 4)
		vinto = 1;
	return vinto;
}


char controlla_diagonale_down (char matrice[8][7], int posx, int posy, int player)
{
	int vinto = 0;
	int i;
	char contatore = 0;
	for (i=0; i <= 6; i++)
	{
	  if ((posx+i) <= 6)
	   if ((posy-i) >= 0)
	   {
		   if ((matrice[posx+i][posy-i]) == player )
		   			contatore = contatore + 1;
		   	else
		   			i = 7;
	   }
	}

	for (i=1; i <= 6; i++)
	{
	  if ((posx-i) >= 0)
	   if ((posy+i) <= 5)
	   {
		if ((matrice[posx-i][posy+i]) == player )
			contatore = contatore + 1;
		else
			i = 7;
	   }
	}
	if (contatore >= 4)
		vinto = 1;
	return vinto;
}

char controlla_vittoria (char matrice[8][7], int posx, int posy, int player)
{
	char vinto = 0;
	vinto =  vinto + controlla_colonna (matrice, posx, posy, player);
	vinto = vinto + controlla_riga (matrice, posx, posy, player);
	vinto = vinto + controlla_diagonale_up (matrice, posx, posy, player);
	vinto = vinto + controlla_diagonale_down (matrice, posx, posy, player);
	return vinto;
}

int main(void)
{
	char aa = 0;
	int x, y, i, ii ;
	int PVP = 1;
	int tipo_di_gioco = 0; //0 no select; 1 singolo; 2 dual
	int tipo_di_gioco_select = 0;
	int gioco = 1;
	int posizione = 0;
	char matrice [8] [7];
	char mossa_corretta;
	char vinto;

	*((volatile unsigned char *)(GPIO_BASE_ADDRESS)) = 0xFF;
	attesa_1(1000);
	attesa_1(1000);
	*((volatile unsigned char *)(PAGESEL_BASE_ADDRESS))= 0x0;
	*((volatile unsigned char *)(GPIO_BASE_ADDRESS)) = 0x99;	// USARE SEMPRE X ABILITARE ACCESSO IN MEMORIA
	//sbianca pag 2 0x100000
	Fill (0x100000, 800, 600, 0, 0, 0xFFFF);

	////////////////////////// FINE FASE INIZIALE
	while (1)
	{
		//prepara pagina 1 per la visualizzazione della presentazione
		Copy (0x0, 0, 0, 800, 600, 0x80000, 0, 0);
		// setta pagina da visualizzare 2
		*((volatile unsigned char *)(PAGESEL_BASE_ADDRESS))= 0x1;

		while (tipo_di_gioco_select == 0) // finch non si preme select = inizio gioco
		{

			//copia trasparente pallino rosso per selezione tipo gioco
			//copia_da_pag_trasp_vert (0x80000, Predx, Predy, buttonL, buttonL, 0x0, 455, 405);
			aa = leggitasti();
			if (aa == 0x3)
			{
				tipo_di_gioco = 1; // player vs cpu
				pallino_gioco(1);
			}
			if (aa == 0x6)
			{
				tipo_di_gioco = 2; //player vs player
				pallino_gioco(2);
			}
			if (aa == 0x5)
			{
				if (tipo_di_gioco == 2)
					tipo_di_gioco_select = tipo_di_gioco;
			}
		}
		// uscita dalla selezione gioco
		//disegno la schermata di gioco a pag 2
		for (x= 1; x <= 7; x++)
			for (y=1; y <=6; y++)
			{
				 casella (x, y, 0);

			}
		for (x= 0; x <= 7; x++)
					for (y=0; y <=6; y++)
					{

						 matrice[x][y]=0;
					}
		//disegno i player colorati
		copia_da_pag_trasp_vert (0x100000, player1_yellowx, player1_yellowy, player1_yellowX, player1_yellowY, 0,  730, 22);
		copia_da_pag_trasp_vert (0x100000, player2_redx, player2_redy, player2_redX, player2_redY, 0, 8, 22);
		// vado a pagina 2
		*((volatile unsigned char *)(PAGESEL_BASE_ADDRESS))= 0x2;

		while (gioco)
		{
		//player 1 ----------------------  GIOCATORE o CPU -----------------------------------
		copia_da_pag_trasp_vert (0x100000, player_grayx, player_grayy, player_grayX, player_grayY, 0, 730, 22);
		copia_da_pag_trasp_vert (0x100000, player2_redx, player2_redy, player2_redX, player2_redY, 0, 8, 22);
		// seleziona posizione
		mossa_corretta = 0;
		posizione = 0;
		while (mossa_corretta == 0)
		{
			if (tipo_di_gioco == 2)   // se giocatore vs giocatore
			{
				posizione = seleziona(1, posizione);
			}
			else
			{
				 seleziona_CPU();
			}
			for (i = 0 ; i<6; i++)
				if ((matrice[posizione][i]) == 0)
				{
					(matrice[posizione][i]) = 1;
					casella(posizione+1,6-i,1);
					ii = i;
					i = 6;
					mossa_corretta = 1;
				}
		}
		// controlla se vinto
		vinto = controlla_vittoria(matrice, posizione, ii, 1);
		while(vinto)
				  {
					casella (posizione+1,6-ii, 3);
					casella (posizione+1,6-ii, 1);
				  }

		//player 2
		copia_da_pag_trasp_vert (0x100000, player_grayx, player_grayy, player_grayX, player_grayY, 0, 8, 22);
		copia_da_pag_trasp_vert (0x100000, player1_yellowx, player1_yellowy, player1_yellowX, player1_yellowY, 0, 730, 22);
		mossa_corretta = 0;
		posizione = 0;
		while (mossa_corretta == 0)
		{
			posizione = seleziona(2, posizione);
			for (i = 0 ; i<6; i++)
				if ((matrice[posizione][i]) == 0)
				{
					(matrice[posizione][i]) = 2;
					casella (posizione+1,6-i, 2);
					ii = i;
					i = 6;
					mossa_corretta = 1;
				}
			}
		//controlla se vinto
		vinto = controlla_vittoria(matrice, posizione, ii, 2);
		while(vinto)
		  {
			casella (posizione+1,6-ii, 3);
			for (i=1; i<1000; i++);
			casella (posizione+1,6-ii, 2);
		  }
		}

		//fine gioco
		// prima di ritornare sopra azzero la selezione gioco
		tipo_di_gioco_select = 0;

	}

    /* all done */
	return(0);
}


