#-- Lattice Semiconductor Corporation Ltd.
#-- Synplify OEM project file C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/tftsurfer/launch_synplify.tcl
#-- Written on Wed Apr  3 15:27:38 2013

project -close
set filename "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/tftsurfer/tftsurfer_syn.prj"
if ([file exists "$filename"]) {
	project -load "$filename"
	project_file -remove *
	} else {
	project -new "$filename"
}

#device options
set_option -technology MACHXO2
set_option -part LCMXO2_7000HC
set_option -package TG144C
set_option -speed_grade -6

#-- add_file options
set_option -include_path "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12"
add_file -verilog "C:/lscc/diamond/2.0/cae_library/synthesis/verilog/machxo2.v"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/monster_manager.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/pixel_addr_data_fifo.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/power_manager.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/sdram_ctrl.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/sdram_pkg.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/tft_on_off_button_ctrl.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/tft_pkg.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/tft_timing_ctrl.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/ipexpress/pixel_addr_fifo.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/ipexpress/pixel_data_fifo.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/ipexpress/pll_block.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/tft_pixel_rgb_pipeliner.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/ipexpress/pixel_rgb_fifo.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../img_mover_viewer.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../micro_emulator.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../spi_flash_reader.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../tftsurfer_demo.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../par_imager/img_spi_sector_rom.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/wb_add_fifo.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/wb_interface.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/wb_data_fifo.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/tftsurfer_top.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../../mico32_ver0/top_conMICO32vhd.vhd"
add_file -verilog "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../../mico32_ver0/platform/soc/platform.v"
add_file -verilog "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../../mico32_ver0/platform/soc/platform_PUR.v"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src_spi/memoria.vhd"
add_file -vhdl -lib "work" "C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src_spi/SPI_top.vhd"
project -result_file {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/tftsurfer/tftsurfer.edi}
project -save "$filename"
